﻿
// タイプライブラリインポート
// ※タイプライブラリの登録は、【CeVIO AI】インストール時に行われます。
// ※import行にエラーが表示される場合、ビルド後に一旦x86に変えてx64に戻すと消えるようです。
#import "libid:7E3B8901-0A65-44A0-9A9A-5F9F822D0716" named_guids rename_namespace("CeVIO")

int main()
{
   // COM初期化
   ::CoInitialize(NULL);

   // ServiceControlインスタンス生成
   CeVIO::IServiceControl2V40* pServiceControl;
   HRESULT result0 = ::CoCreateInstance(CeVIO::CLSID_ServiceControl2V40,
      NULL,
      CLSCTX_INPROC_SERVER,
      CeVIO::IID_IServiceControl2V40,
      reinterpret_cast<LPVOID*>(&pServiceControl));
   if (FAILED(result0)) {
      // 失敗
      ::CoUninitialize();
      return 0;
   }

   // 【CeVIO AI】起動
   pServiceControl->StartHost(false);

   // Talkerインスタンス生成
   CeVIO::ITalker2V40* pTalker;
   HRESULT result1 = ::CoCreateInstance(CeVIO::CLSID_Talker2V40,
      NULL,
      CLSCTX_INPROC_SERVER,
      CeVIO::IID_ITalker2V40,
      reinterpret_cast<LPVOID*>(&pTalker));
   if (FAILED(result1)) {
      // 失敗
      ::CoUninitialize();
      return 0;
   }

   // キャスト設定
   pTalker->Cast = "さとうささら";

   // （例）音量設定
   pTalker->Volume = 100;

   // （例）抑揚設定
   pTalker->ToneScale = 100;

   // （例）再生
   CeVIO::ISpeakingState2Ptr pState = pTalker->Speak("こんにちは");
   pState->Wait();

   // （例）音素データ取得
   CeVIO::IPhonemeDataArray2Ptr pPhonemes = pTalker->GetPhonemes("はじめまして");

   // Talker解放
   pTalker->Release();

   // 【CeVIO AI】終了
   pServiceControl->CloseHost(0);

   // ServiceControl解放
   pServiceControl->Release();

   // COM使用終了
   ::CoUninitialize();

   return 0;
}
